/*-
|> File
|| drawcmd.h
||
|> Description
||
||
|> Comments
||
||
|> History
|| 95061 _mf Created.
||
||==================================================================|>
*/
#ifndef _dir_drawcmd_h
#define _dir_drawcmd_h

#ifndef _NOIDENT
#ident "$Id: drawcmd.h,v 2.2 1995/09/29 18:45:05 mfischer Exp $"
#endif

void                    polyfillrectangle (FILE * fp,
                                           Window win,
                                           XGCValues *gcv,
                                           int nrect,
                                           XRectangle *rectangles);

void                    fillpoly (FILE * fp,
                                  Window win,
                                  XGCValues *gcv,
                                  int npoint,
                                  int coordmode,
                                  XPoint *points);

void                    polyline (FILE * fp,
                                  Window win,
                                  XGCValues *gcv,
                                  int npoint,
                                  int coordmode,
                                  XPoint *points);

void                    polytext8 (FILE * fp,
                                   Window win,
                                   XGCValues *gcv,
                                   int x,
                                   int y,
                                   int ntext,
                                   unsigned char *buffer);

void                    polytext16 (FILE * fp,
                                    Window win,
                                    XGCValues *gcv,
                                    int x,
                                    int y,
                                    int ntext,
                                    unsigned char *buffer);

void                    imagetext8 (FILE * fp,
                                    Window win,
                                    XGCValues *gcv,
                                    int x,
                                    int y,
                                    int ntext,
                                    unsigned char *buffer);

void                    imagetext16 (FILE * fp,
                                     Window win,
                                     XGCValues *gcv,
                                     int x,
                                     int y,
                                     int ntext,
                                     unsigned char *buffer);


long                    pad (const long n);


#if 0
short                   GetServerPort ();

short                   GetScopePort ();

char                   *OfficialName (
                                       char *name
);

void                    Usage ();

void                    ScanArgs (
                                   int argc,
                                   char **argv
);

void                    SetUpPair (
                                    FD client,
                                    FD server
);

void                    CloseConnection (
                                          FD fd
);

FD                      FDPair (
                                 FD fd
);

FD                      ClientHalf (
                                     FD fd
);

FD                      ServerHalf (
                                     FD fd
);

char                   *ClientName (
                                     FD fd
);

int                     DataFromClient (
                                         FD fd
);

int                     DataFromServer (
                                         FD fd
);

int                     NewConnection (
                                        FD fd
);

FD                      ConnectToClient (
                                          FD ConnectionSocket
);

FD                      ConnectToServer (
                                          Bool report
);

char                   *OfficialName (
                                       char *name
);

void                    InitializeFD ();

void                    UsingFD (
                                  FD fd,
                                  int                     (*Handler) ()
);

void                    NotUsingFD (
                                     FD fd
);

void                    EOFonFD (
                                  FD fd
);

void                    MainLoop ();

void                    SetUpConnectionSocket (
                                                int iport
);

int                     GetConnSetupLength (
                                             unsigned char *buf
);

int                     GetRequestLength (
                                           unsigned char *buf
);

int                     GetReplyLength (
                                         unsigned char *buf
);

int                     GetConnSetupReplyLength (
                                                  unsigned char *buf
);

void                    StartClientConnection (
                                                FD fd
);

void                    scrunch (
                                  unsigned char *buf,
                                  int start,
                                  int length
);

void                    splice (
                                 unsigned char *buf,
                                 unsigned char *insert,
                                 int buflen,
                                 int inslen
);

Bool                    InterceptRequest (
                                           FD fd,
                                           unsigned char *buf,
                                           unsigned char **newmsg,
                                           int *newlen
);

void                    ReplaceReply (
                                       FD fd,
                                       unsigned char *buf,
                                       int length
);

void                    ProcessRequest (
                                         FD fd,
                                         unsigned char *buf,
                                         unsigned char **sndbuf,
                                         int *sendlen
);

void                    EatMessage (
                                     FD fd,
                                     int length
);

void                    ProcessReply (
                                       FD fd,
                                       unsigned char *buf,
                                       unsigned char **sndbuf,
                                       int *sendlen
);

char                   *lookupTag (
                                    int tag,
                                    lookupPtr table
);

Bool                    ReplyExpected (
                                        unsigned char *buf
);

Bool                    isReply (
                                  unsigned char *buf
);

unsigned char          *HeadDelete (
                                     struct PrintClient *pcs,
                                     unsigned char *buf,
                                     int *sendlen
);

Bool                    MidDelete (
                                    struct PrintClient *pcs,
                                    unsigned char *p,
                                    unsigned char **end,
                                    int *sendlen
);

void                    setCurrGc (
                                    FD fd,
                                    FILE * fp,
                                    XGCValues *gcvp,
                                    Colormap cmap
);

/* set the values in a GC given the flags and the data buffer from a request */

void                    setGcvalues (
                                      FD fd,
                                      FILE * fp,
                                      XGCValues *gcvp,
                                      unsigned long value_mask,
                                      unsigned long *request,
                                      Colormap cmap
);

gcinfoPtr               getgcinfo (
                                    unsigned long gcid,
                                    gcinfoTablePtr table
);

winfoPtr                getwinfo (
                                   unsigned long win,
                                   winfoTablePtr table
);

cmapinfoPtr             getcmapinfo (
                                      unsigned long cmap,
                                      cmapinfoTablePtr table
);

winfoPtr                getgenwinfo (
                                      unsigned long win,
                                      winfoTablePtr table
);

Bool                    DecodeRequest (FD fd,
                                       unsigned char *buf,
                                       unsigned char *newmsg,
                                       int *newlen);

void                    initprocs (
                                    struct PrintClient *pc,
                                    int fd
);

void                    setcolor (
                                   FD fd,
                                   FILE * fp,
                                   unsigned long pixel,
                                   Colormap cmap
);

void                    setlinewidth (
                                       FILE * fp,
                                       int line_width
);

void                    setlinecap (
                                     FILE * fp,
                                     int cap_style
);

void                    setlinejoin (
                                      FILE * fp,
                                      int join_style
);

int                     setfont (
                                  FD fd,
                                  FILE * fp,
                                  Font fontId
);

void                    polyfillrectangle (
                                            FILE * fp,
                                            Window win,
                                            XGCValues *gcv,
                                            int nrect,
                                            XRectangle *rectangles
);

void                    polyrectangle (
                                        FILE * fp,
                                        Window win,
                                        XGCValues *gcv,
                                        int nrect,
                                        XRectangle *rectangles
);

void                    fillpoly (
                                   FILE * fp,
                                   Window win,
                                   XGCValues *gcv,
                                   int npoint,
                                   int coordmode,
                                   XPoint *points
);

void                    polyline (
                                   FILE * fp,
                                   Window win,
                                   XGCValues *gcv,
                                   int npoint,
                                   int coordmode,
                                   XPoint *points
);

void                    polysegment (
                                      FILE * fp,
                                      Window win,
                                      XGCValues *gcv,
                                      int nseg,
                                      XSegment *segments
);

void                    polytext8 (
                                    FILE * fp,
                                    Window win,
                                    XGCValues *gcv,
                                    int x,
                                    int y,
                                    int ntext,
                                    unsigned char *buffer
);

void                    polytext16 (
                                     FILE * fp,
                                     Window win,
                                     XGCValues *gcv,
                                     int x,
                                     int y,
                                     int ntext,
                                     unsigned char *buffer
);

void                    imagetext8 (
                                     FILE * fp,
                                     Window win,
                                     XGCValues *gcv,
                                     int x,
                                     int y,
                                     int ntext,
                                     unsigned char *buffer
);

void                    imagetext16 (
                                      FILE * fp,
                                      Window win,
                                      XGCValues *gcv,
                                      int x,
                                      int y,
                                      int ntext,
                                      unsigned char *buffer
);

void                    cleararea (
                                    FILE * fp,
                                    Window win,
                                    XWindowAttributes *attr,
                                    int x,
                                    int y,
                                    int width,
                                    int height
);

void                    putimage (
                                   int fd,
                                   FILE * fp,
                                   Window win,
                                   XGCValues *gcv,
                                   int depth,
                                   int width,
                                   int height,
                                   int x,
                                   int y,
                                   int leftpad,
                                   int format,
                                   int numColors,
                                   XColor *colors,
                                   unsigned char *data
);

void                    copyarea (
                                   FILE * fp,
                                   Drawable src,
                                   Window win,
                                   int srcX,
                                   int srcY,
                                   int dstX,
                                   int dstY,
                                   int width,
                                   int height,
                                   int numColors,
                                   XColor *colors
);

void                    copyGcvalues (XGCValues *gcvp,
                                      XGCValues *srcGcvp,
                                      unsigned long value_mask);

char                   *getPostName (char *xfont);

void                    initPrintClients (struct PrintClient *pcs,
                                          int numclients);

int                     readLoop (int fd,
                                  char *msg,
                                  int length);

int                     initConnection (int clientFd);

void                    polypoint (FILE * fp,
                                   Window win,
                                   XGCValues *gcv,
                                   int npoint,
                                   int coordmode,
                                   XPoint *points);

void                    polyarc (FILE * fp,
                                 Window win,
                                 XGCValues *gcv,
                                 int narc,
                                 xArc * arcs);

void                    printImageGrey (unsigned char *image,
                                        int x,
                                        int y,
                                        int width,
                                        int height,
                                        int depth,
                                        XColor *colors,
                                        int numColors,
                                        FILE * fp,
                                        int indexSupport);

char                  **readStrvec (char *filename);

char                  **readStrvec (char *filename);
#endif

#endif

/*- end drawcmd.h
*/
